<template>
  <div class="canvas-slot-grand-child">
    <div
      ref="timeline"
      class="timeline"
    >
      <slot
        name="timeline"
        :view-rect="viewRect"
      />
    </div>
    <div
      ref="scroller"
      class="scroller"
      :class="hasMinimap ? 'hide-scrollbar' : ''"
      @scroll="onScroll"
    >
      <slot
        :actions="actions"
        :view-rect="viewRect"
      />
    </div>
    <v-scale-transition>
      <div
        v-if="hasMinimap"
        v-show="!isAllVisible"
        :key="isAllVisible"
        ref="minimap"
        :class="{ 'secondary': $store.state.secondaryColor,
                  'sync-minimap': isSync }"
        class="minimap hide-scrollbar"
      >
        <slot
          name="minimap"
          :actions="actions"
          :view-rect="viewRect"
        /><!--
        -->
      </div><!--
      -->
    </v-scale-transition><!--
    -->
  </div>
</template>

<script lang="ts">
import {
  Ref, Vue, Component, Prop, Watch, PropSync,
} from 'vue-property-decorator';
import type {
  Rect, Pixel, Unit, Point,
} from '@/data';
import type ScrollActions from '@/logic/ScrollActions';
import type Zoom from '@/logic/Zoom';

export const enum Visibility {
  HiddenLeft = -1,
  Visible = 0,
  HiddenRight = 1,
}

@Component
export default class CanvasScroller extends Vue {
  // Accessors

  @Prop({ default: false })
  isSync!: boolean;

  @Prop({ default: false })
  hasMinimap!: boolean;

  @Prop()
  width!: number;

  @Prop({ default: false, type: Boolean })
  autoZoom!: boolean;

  @PropSync('zoom')
  zoomSync!: Zoom;

  viewRect: Rect = {
    x: 0, y: 0, width: 0, height: 0,
  } as Rect;

  isAllVisible = false;

  @Ref()
  scroller!: HTMLElement;

  @Ref()
  minimap!: HTMLElement;

  @Ref()
  timeline!: HTMLElement;

  @Prop({ default: null })
  pixelUnit!: Unit<Pixel> | null;

  // API

  /**
   * Scroll to a position in Pixel
   */
  public goTo(target: Point, smooth = true): void {
    this.scroller.scrollTo({
      top: (target.y - 200) * this.zoomSync.value,
      left: target.x * this.zoomSync.value,
      behavior: smooth ? 'smooth' : 'auto',
    });
  }

  /**
   * Maximize the visibility of a target range
   */
  public goToRange(start: Pixel, width: Pixel, smooth = true): void {
    const end = (start + width) as Pixel;
    const startVisibility = this.getVisibility(start);
    const endVisibility = this.getVisibility(end);

    let target: Pixel;

    // If range start is hidden to the left or to the right
    if ((startVisibility < 0) || (startVisibility > 0)) {
      // Place range start at screen start
      target = start;
    // If range end is hidden to the right
    } else if (endVisibility > 0) {
      // If it's impossible to show range fully, show start
      if (width > this.viewRect.width) {
        target = start;
      // Otherwise, show the entire range
      } else {
        target = (end - this.viewRect.width) as Pixel;
      }
    } else {
      return;
    }
    this.goTo({ x: target, y: 0 } as Point, smooth);
  }

  /**
   * Returns the visibility of a position (excluding margins)
   * -1 if the position is to the left of the view
   * 0 if the position is visible
   * 1 if the position is to the right of the view
   */
  public getVisibility(target: Pixel): Visibility {
    const leftEdge = this.viewRect.x;
    const rightEdge = this.viewRect.x + this.viewRect.width;

    if (target < leftEdge) {
      return -1;
    }
    if (target > rightEdge) {
      return 1;
    }
    return 0;
  }

  get actions(): ScrollActions {
    const { goTo, goToRange } = this;
    return { goTo, goToRange };
  }

  // Events

  @Watch('zoomSync', { deep: true })
  updateViewRect() {
    this.viewRect.x = (this.scroller.scrollLeft / this.zoomSync.value) as Pixel;
    this.viewRect.y = (this.scroller.scrollTop / this.zoomSync.value) as Pixel;
    this.viewRect.height = (this.scroller.clientHeight / this.zoomSync.value) as Pixel;
    this.viewRect.width = (this.scroller.clientWidth / this.zoomSync.value) as Pixel;

    // Calculate the minimap scroll, if it spills over the sides
    if (this.hasMinimap && this.minimap) {
      // https://stackoverflow.com/questions/2387136/cross-browser-method-to-determine-vertical-scroll-percentage-in-javascript
      const scrollRatio = this.scroller.scrollLeft
      / (this.scroller.scrollWidth - this.scroller.clientWidth)
      || 0;

      const minibarLeft = scrollRatio * (this.minimap.scrollWidth - this.minimap.clientWidth);

      this.minimap.scrollTo({ left: minibarLeft });
    }
    this.timeline.scrollLeft = this.scroller.scrollLeft;

    this.isAllVisible = this.scroller.scrollLeft === 0
      && this.scroller.scrollWidth === this.scroller.clientWidth;
  }

  mounted() {
    // init viewrect
    this.updateViewRect();
    if (this.autoZoom) {
      const value = this.viewRect.width / this.width;
      this.zoomSync.exponent = this.zoomSync.getExponentForValue(value);
      this.updateViewRect();
    }
  }

  onScroll() {
    if (!this.scroller) return;

    this.updateViewRect();
  }

  @Watch('zoom')
  onZoom() {
    this.goTo({ x: this.viewRect.x, y: this.viewRect.y } as Point, false);
    this.updateViewRect();
  }

  // @Watch('pixelUnit')
  // onPixelChange(current: Unit<Pixel>, old: Unit<Pixel>) {
  //   // this.goTo(current.fromOnset(old.toOnset(this.viewRect.x)), false);
  //   this.updateViewRect();
  // }
}
</script>
<style scoped lang="scss">
.canvas-slot-grand-child {
  display: flex;
  flex-direction: column;
  height: 100%;
}
.timeline {
  overflow: hidden;
  scroll-behavior: auto;
}
.scroller{
  height: 100%;
  overflow: scroll;
  right:0px;
  // scroll-behavior: smooth;
  // Fixes double visible vertical scrollbar
  overflow-y: auto;
  // sets scrollbar colors to scheme
  scrollbar-color: var(--v-primary-darken2) var(--v-secondary-base);
  // Set position to relative to allow cursor to be absolute
  position: relative;
  padding-bottom: 5px;
}
.minimap{
  right:0px;
  text-align: center;
  //Remove space after div cause by stray whitespace
  font-size: 0;
}
.hide-scrollbar{
  scrollbar-width: none;
}
.hide-scrollbar::-webkit-scrollbar {
  display: none;
}

.minimap {
  position: sticky;
  bottom: 0;
}
</style>
